public class Rar {
	Main main;
	static int MAX_SIZE;
	static int MAXWINSIZE;
	static int MAXWINMASK;
	static final int SIZEOF_SHORTBLOCKHEAD = 7;
	static final int LHD_SOLID = 16;
	static final int ATTR_SUB = 16;
	static final int LOW_DIST_REP_COUNT = 16;
	static final int BLOCK_LZ = 0;
	static final int BLOCK_PPM = 1;
	static final byte[] LDecode;
	static final byte[] LBits;
	static final int[] DDecode;
	static final byte[] DBits;
	static final int[] DBitLengthCounts;
	static final byte[] SDDecode;
	static final byte[] SDBits;
	static final int STARTL1 = 2;
	static final int[] DecL1;
	static final int[] PosL1;
	static final int STARTL2 = 3;
	static final int[] DecL2;
	static final int[] PosL2;
	static final int STARTHF0 = 4;
	static final int[] DecHf0;
	static final int[] PosHf0;
	static final int STARTHF1 = 5;
	static final int[] DecHf1;
	static final int[] PosHf1;
	static final int STARTHF2 = 5;
	static final int[] DecHf2;
	static final int[] PosHf2;
	static final int STARTHF3 = 6;
	static final int[] DecHf3;
	static final int[] PosHf3;
	static final int STARTHF4 = 8;
	static final int[] DecHf4;
	static final int[] PosHf4;
	static int[] ShortLen1;
	static int[] ShortXor1;
	static int[] ShortLen2;
	static int[] ShortXor2;
	static final int NC = 299;
	static final int DC = 60;
	static final int LDC = 17;
	static final int RC = 28;
	static final int HUFF_TABLE_SIZE = 404;
	static final int BC = 20;
	static final int NC20 = 298;
	static final int DC20 = 48;
	static final int RC20 = 28;
	static final int BC20 = 19;
	static final int MC20 = 257;
	static final int[] LLSize;
	int[] DecodeN;
	Rar.Decode[] LL;
	Rar.AudioVariables[] AudV;
	byte[] UnpOldTable;
	byte[] Window;
	byte[] InBuf;
	int InAddr;
	int InBit;
	int PPMEscChar;
	int LastFilter;
	boolean TablesRead;
	int[] OldDist;
	int OldDistPtr;
	int LastDist;
	int LastLength;
	int UnpPtr;
	int WrPtr;
	int ReadTop;
	int ReadBorder;
	int UnpBlockType;
	int DestUnpSize;
	boolean Suspended;
	boolean UnpAllBuf;
	boolean UnpSomeRead;
	int WrittenFileSize;
	boolean FileExtracted;
	boolean PPMError;
	int PrevLowDist;
	int LowDistRepCount;
	int[] ChSet;
	int[] ChSetA;
	int[] ChSetB;
	int[] ChSetC;
	int[] Place;
	int[] PlaceA;
	int[] PlaceB;
	int[] PlaceC;
	int[] NToPl;
	int[] NToPlB;
	int[] NToPlC;
	int FlagBuf;
	int AvrPlc;
	int AvrPlcB;
	int AvrLn1;
	int AvrLn2;
	int AvrLn3;
	int Buf60;
	int NumHuf;
	int StMode;
	int LCount;
	int FlagsCnt;
	int Nhfb;
	int Nlzb;
	int MaxDist3;
	byte[] UnpOldTable20;
	int UnpAudioBlock;
	int UnpChannels;
	int UnpCurChannel;
	int UnpChannelDelta;

	void InitLL() {
		int i;
		for (int decodePtr = i = 0; i < 13; ++i) {
			this.LL[i].DecodePtr = decodePtr;
			this.LL[i].DecodeCnt = Rar.LLSize[i];
			decodePtr += Rar.LLSize[i];
		}
	}

	void clrAudV() {
		for (int i = 0; i < 4; ++i) {
			final Rar.AudioVariables audioVariables = this.AudV[i];
			final Rar.AudioVariables audioVariables2 = this.AudV[i];
			final Rar.AudioVariables audioVariables3 = this.AudV[i];
			final Rar.AudioVariables audioVariables4 = this.AudV[i];
			final Rar.AudioVariables audioVariables5 = this.AudV[i];
			final Rar.AudioVariables audioVariables6 = this.AudV[i];
			final Rar.AudioVariables audioVariables7 = this.AudV[i];
			final Rar.AudioVariables audioVariables8 = this.AudV[i];
			final Rar.AudioVariables audioVariables9 = this.AudV[i];
			final Rar.AudioVariables audioVariables10 = this.AudV[i];
			final Rar.AudioVariables audioVariables11 = this.AudV[i];
			final Rar.AudioVariables audioVariables12 = this.AudV[i];
			final boolean b = false;
			audioVariables12.LastChar = (b ? 1 : 0);
			audioVariables11.ByteCount = (b ? 1 : 0);
			audioVariables10.LastDelta = (b ? 1 : 0);
			audioVariables9.D4 = (b ? 1 : 0);
			audioVariables8.D3 = (b ? 1 : 0);
			audioVariables7.D2 = (b ? 1 : 0);
			audioVariables6.D1 = (b ? 1 : 0);
			audioVariables5.K5 = (b ? 1 : 0);
			audioVariables4.K4 = (b ? 1 : 0);
			audioVariables3.K3 = (b ? 1 : 0);
			audioVariables2.K2 = (b ? 1 : 0);
			audioVariables.K1 = (b ? 1 : 0);
			for (int j = 0; j < 11; ++j) {
				this.AudV[i].Dif[j] = 0;
			}
		}
	}

	Rar(final Main main) {
		this.DecodeN = new int[1845];
		this.LL = new Rar.Decode[] { new Rar.Decode(this), new Rar.Decode(this), new Rar.Decode(this),
				new Rar.Decode(this), new Rar.Decode(this), new Rar.Decode(this), new Rar.Decode(this),
				new Rar.Decode(this), new Rar.Decode(this), new Rar.Decode(this), new Rar.Decode(this),
				new Rar.Decode(this), new Rar.Decode(this) };
		this.AudV = new Rar.AudioVariables[] { new Rar.AudioVariables(this), new Rar.AudioVariables(this),
				new Rar.AudioVariables(this), new Rar.AudioVariables(this) };
		this.UnpOldTable = new byte[404];
		this.Window = null;
		this.InBuf = null;
		this.OldDist = new int[4];
		this.ChSet = new int[256];
		this.ChSetA = new int[256];
		this.ChSetB = new int[256];
		this.ChSetC = new int[256];
		this.Place = new int[256];
		this.PlaceA = new int[256];
		this.PlaceB = new int[256];
		this.PlaceC = new int[256];
		this.NToPl = new int[256];
		this.NToPlB = new int[256];
		this.NToPlC = new int[256];
		this.UnpOldTable20 = new byte[1028];
		this.main = main;
	}

	void InitBitInput() {
		final boolean b = false;
		this.InBit = (b ? 1 : 0);
		this.InAddr = (b ? 1 : 0);
	}

	void addbits(int n) {
		n += this.InBit;
		this.InAddr += n >> 3;
		this.InBit = (n & 0x7);
	}

	int getbits() {
		return ((this.InBuf[this.InAddr] & 0xFF) << 16 | (this.InBuf[this.InAddr + 1] & 0xFF) << 8
				| (this.InBuf[this.InAddr + 2] & 0xFF)) >> 8 - this.InBit & 0xFFFF;
	}

	boolean IsFileExtracted() {
		return this.FileExtracted;
	}

	void SetDestSize(final int destUnpSize) {
		this.DestUnpSize = destUnpSize;
		this.FileExtracted = false;
	}

	void SetSuspended(final boolean suspended) {
		this.Suspended = suspended;
	}

	void UnpackInit(final byte[] inBuf, final int max_SIZE) {
		int n = 0;
		final boolean b = false;
		this.InBit = (b ? 1 : 0);
		this.InAddr = (b ? 1 : 0);
		this.Suspended = false;
		this.UnpAllBuf = false;
		this.UnpSomeRead = false;
		this.InBuf = inBuf;
		Rar.MAX_SIZE = max_SIZE;
		if (this.Window == null) {
			Runtime.getRuntime().gc();
			Rar.MAXWINSIZE = (int) Runtime.getRuntime().freeMemory();
			while (Rar.MAXWINSIZE > 0) {
				++n;
				Rar.MAXWINSIZE >>= 1;
			}
			Rar.MAXWINSIZE = 1 << n - 1;
			this.Window = new byte[Rar.MAXWINSIZE];
			Rar.MAXWINMASK = Rar.MAXWINSIZE - 1;
		}
		this.InitLL();
		this.UnpInitData(false);
	}

	void UnpackFree() {
		this.Window = null;
	}

	void DoUnpack(final int n, final boolean b) {
		switch (n) {
		case 10:
		case 11:
		case 12:
		case 13:
		case 14:
		case 15: {
			this.Unpack15(b);
			break;
		}
		case 20:
		case 26: {
			this.Unpack20(b);
			break;
		}
		case 29:
		case 36: {
			this.Unpack29(b);
			break;
		}
		}
	}

	void InsertOldDist(final int n) {
		this.OldDist[3] = this.OldDist[2];
		this.OldDist[2] = this.OldDist[1];
		this.OldDist[1] = this.OldDist[0];
		this.OldDist[0] = n;
	}

	void InsertLastMatch(final int lastLength, final int lastDist) {
		this.LastDist = lastDist;
		this.LastLength = lastLength;
	}

	void CopyString(int n, final int n2) {
		int n3 = this.UnpPtr - n2;
		if (n3 < 0) {
			n3 += Rar.MAXWINSIZE;
		}
		if (n3 < Rar.MAXWINSIZE - 260 && this.UnpPtr < Rar.MAXWINSIZE - 260) {
			this.Window[this.UnpPtr++] = this.Window[n3++];
			while (--n > 0) {
				this.Window[this.UnpPtr++] = this.Window[n3++];
			}
		} else {
			while (n-- > 0) {
				this.Window[this.UnpPtr] = this.Window[n3++ & Rar.MAXWINMASK];
				this.UnpPtr = (this.UnpPtr + 1 & Rar.MAXWINMASK);
			}
		}
	}

	int DecodeNumber(final int n) {
		final int n2 = this.getbits() & 0xFFFE;
		int n3;
		if (n2 < this.LL[n].DecodeLen[8]) {
			if (n2 < this.LL[n].DecodeLen[4]) {
				if (n2 < this.LL[n].DecodeLen[2]) {
					if (n2 < this.LL[n].DecodeLen[1]) {
						n3 = 1;
					} else {
						n3 = 2;
					}
				} else if (n2 < this.LL[n].DecodeLen[3]) {
					n3 = 3;
				} else {
					n3 = 4;
				}
			} else if (n2 < this.LL[n].DecodeLen[6]) {
				if (n2 < this.LL[n].DecodeLen[5]) {
					n3 = 5;
				} else {
					n3 = 6;
				}
			} else if (n2 < this.LL[n].DecodeLen[7]) {
				n3 = 7;
			} else {
				n3 = 8;
			}
		} else if (n2 < this.LL[n].DecodeLen[12]) {
			if (n2 < this.LL[n].DecodeLen[10]) {
				if (n2 < this.LL[n].DecodeLen[9]) {
					n3 = 9;
				} else {
					n3 = 10;
				}
			} else if (n2 < this.LL[n].DecodeLen[11]) {
				n3 = 11;
			} else {
				n3 = 12;
			}
		} else if (n2 < this.LL[n].DecodeLen[14]) {
			if (n2 < this.LL[n].DecodeLen[13]) {
				n3 = 13;
			} else {
				n3 = 14;
			}
		} else {
			n3 = 15;
		}
		this.addbits(n3);
		int n4 = this.LL[n].DecodePos[n3] + (n2 - this.LL[n].DecodeLen[n3 - 1] >> 16 - n3);
		if (n4 < 0 || n4 >= this.LL[n].MaxNum) {
			n4 = 0;
		}
		return this.DecodeN[this.LL[n].DecodePtr + n4];
	}

	void Unpack29(final boolean b) {
		this.FileExtracted = true;
		if (!this.Suspended) {
			this.UnpInitData(b);
			if (!this.UnpReadBuf()) {
				return;
			}
			if ((!b || !this.TablesRead) && !this.ReadTables()) {
				return;
			}
		}
		if (this.PPMError) {
			return;
		}
		while (true) {
			this.UnpPtr &= Rar.MAXWINMASK;
			if (this.InAddr > this.ReadBorder && !this.UnpReadBuf()) {
				break;
			}
			if ((this.WrPtr - this.UnpPtr & Rar.MAXWINMASK) < 260 && this.WrPtr != this.UnpPtr) {
				this.UnpWriteBuf();
				if (this.WrittenFileSize > this.DestUnpSize) {
					return;
				}
				if (this.Suspended) {
					this.FileExtracted = false;
					return;
				}
			}
			if (this.UnpBlockType == 1) {
				return;
			}
			int decodeNumber = this.DecodeNumber(0);
			if (decodeNumber < 256) {
				this.Window[this.UnpPtr++] = (byte) decodeNumber;
			} else if (decodeNumber >= 271) {
				final byte[] lDecode = Rar.LDecode;
				decodeNumber -= 271;
				int n = (lDecode[decodeNumber] & 0xFF) + 3;
				final int n2;
				if ((n2 = (Rar.LBits[decodeNumber] & 0xFF)) > 0) {
					n += this.getbits() >> 16 - n2;
					this.addbits(n2);
				}
				final int decodeNumber2 = this.DecodeNumber(1);
				int n3 = Rar.DDecode[decodeNumber2] + 1;
				final int n4;
				if ((n4 = (Rar.DBits[decodeNumber2] & 0xFF)) > 0) {
					if (decodeNumber2 > 9) {
						if (n4 > 4) {
							n3 += this.getbits() >> 20 - n4 << 4;
							this.addbits(n4 - 4);
						}
						if (this.LowDistRepCount > 0) {
							--this.LowDistRepCount;
							n3 += this.PrevLowDist;
						} else {
							final int decodeNumber3 = this.DecodeNumber(4);
							if (decodeNumber3 == 16) {
								this.LowDistRepCount = 15;
								n3 += this.PrevLowDist;
							} else {
								n3 += decodeNumber3;
								this.PrevLowDist = decodeNumber3;
							}
						}
					} else {
						n3 += this.getbits() >> 16 - n4;
						this.addbits(n4);
					}
				}
				if (n3 >= 8192) {
					++n;
					if (n3 >= 262144L) {
						++n;
					}
				}
				this.InsertOldDist(n3);
				this.InsertLastMatch(n, n3);
				this.CopyString(n, n3);
			} else if (decodeNumber == 256) {
				if (!this.ReadEndOfBlock()) {
					break;
				}
				continue;
			} else {
				if (decodeNumber == 257) {
					break;
				}
				if (decodeNumber == 258) {
					if (this.LastLength == 0) {
						continue;
					}
					this.CopyString(this.LastLength, this.LastDist);
				} else if (decodeNumber < 263) {
					final int n5 = decodeNumber - 259;
					final int n6 = this.OldDist[n5];
					for (int i = n5; i > 0; --i) {
						this.OldDist[i] = this.OldDist[i - 1];
					}
					this.OldDist[0] = n6;
					final int decodeNumber4 = this.DecodeNumber(2);
					int n7 = (Rar.LDecode[decodeNumber4] & 0xFF) + 2;
					final int n8;
					if ((n8 = (Rar.LBits[decodeNumber4] & 0xFF)) > 0) {
						n7 += this.getbits() >> 16 - n8;
						this.addbits(n8);
					}
					this.InsertLastMatch(n7, n6);
					this.CopyString(n7, n6);
				} else {
					if (decodeNumber >= 272) {
						continue;
					}
					final byte[] sdDecode = Rar.SDDecode;
					decodeNumber -= 263;
					int n9 = (sdDecode[decodeNumber] & 0xFF) + 1;
					final int n10;
					if ((n10 = (Rar.SDBits[decodeNumber] & 0xFF)) > 0) {
						n9 += this.getbits() >> 16 - n10;
						this.addbits(n10);
					}
					this.InsertOldDist(n9);
					this.InsertLastMatch(2, n9);
					this.CopyString(2, n9);
				}
			}
		}
		this.UnpWriteBuf();
	}

	boolean ReadEndOfBlock() {
		final int getbits = this.getbits();
		boolean b = false;
		boolean b2;
		if ((getbits & 0x8000) != 0x0) {
			b2 = true;
			this.addbits(1);
		} else {
			b = true;
			b2 = ((getbits & 0x4000) != 0x0);
			this.addbits(2);
		}
		this.TablesRead = !b2;
		return !b && (!b2 || this.ReadTables());
	}

	boolean UnpReadBuf() {
		int readTop = this.ReadTop - this.InAddr;
		if (readTop < 0) {
			return false;
		}
		if (this.InAddr > Rar.MAX_SIZE / 2) {
			if (readTop > 0) {
				System.arraycopy(this.InBuf, this.InAddr, this.InBuf, 0, readTop);
			}
			this.InAddr = 0;
			this.ReadTop = readTop;
		} else {
			readTop = this.ReadTop;
		}
		final int unpRead = this.main.UnpRead(readTop, Rar.MAX_SIZE - readTop & 0xFFFFFFF0);
		if (unpRead > 0) {
			this.ReadTop += unpRead;
		}
		this.ReadBorder = this.ReadTop - 30;
		return unpRead != -1;
	}

	void UnpWriteBuf() {
		final int wrPtr = this.WrPtr;
		final int n = this.UnpPtr - wrPtr & Rar.MAXWINMASK;
		this.UnpWriteArea(wrPtr, this.UnpPtr);
		this.WrPtr = this.UnpPtr;
	}

	void UnpWriteArea(final int n, final int n2) {
		if (n2 != n) {
			this.UnpSomeRead = true;
		}
		if (n2 < n) {
			this.UnpWriteData(n, -n & Rar.MAXWINMASK);
			this.UnpWriteData(0, n2);
			this.UnpAllBuf = true;
		} else {
			this.UnpWriteData(n, n2 - n);
		}
	}

	void UnpWriteData(final int n, final int n2) {
		if (this.WrittenFileSize >= this.DestUnpSize) {
			return;
		}
		int n3 = n2;
		final int n4 = this.DestUnpSize - this.WrittenFileSize;
		if (n3 > n4) {
			n3 = n4;
		}
		this.main.UnpWrite(n, n3);
		this.WrittenFileSize += n2;
	}

	boolean ReadTables() {
		final byte[] array = new byte[20];
		final byte[] array2 = new byte[404];
		if (this.InAddr > this.ReadTop - 25 && !this.UnpReadBuf()) {
			return false;
		}
		this.addbits(8 - this.InBit & 0x7);
		final int getbits = this.getbits();
		if ((getbits & 0x8000) != 0x0) {
			this.UnpBlockType = 1;
			return false;
		}
		this.UnpBlockType = 0;
		this.PrevLowDist = 0;
		this.LowDistRepCount = 0;
		if ((getbits & 0x4000) == 0x0) {
			for (int i = 0; i < this.UnpOldTable.length; ++i) {
				this.UnpOldTable[i] = 0;
			}
		}
		this.addbits(2);
		for (int j = 0; j < 20; ++j) {
			final int n = this.getbits() >> 12;
			this.addbits(4);
			if (n == 15) {
				int n2 = this.getbits() >> 12;
				this.addbits(4);
				if (n2 == 0) {
					array[j] = 15;
				} else {
					for (n2 += 2; n2-- > 0 && j < array.length; array[j++] = 0) {
					}
					--j;
				}
			} else {
				array[j] = (byte) n;
			}
		}
		this.MakeDecodeTables(array, 0, 3);
		for (int n3 = 404, k = 0; k < n3; ++k) {
			if (this.InAddr > this.ReadTop - 5 && !this.UnpReadBuf()) {
				return false;
			}
			final int decodeNumber = this.DecodeNumber(3);
			if (decodeNumber < 16) {
				array2[k] = (byte) (decodeNumber + this.UnpOldTable[k] & 0xF);
			} else if (decodeNumber < 18) {
				int n4;
				if (decodeNumber == 16) {
					n4 = (this.getbits() >> 13) + 3;
					this.addbits(3);
				} else {
					n4 = (this.getbits() >> 9) + 11;
					this.addbits(7);
				}
				while (n4-- > 0 && k < n3) {
					array2[k] = array2[k - 1];
					++k;
				}
			} else {
				int n5;
				if (decodeNumber == 18) {
					n5 = (this.getbits() >> 13) + 3;
					this.addbits(3);
				} else {
					n5 = (this.getbits() >> 9) + 11;
					this.addbits(7);
				}
				while (n5-- > 0 && k < n3) {
					array2[k++] = 0;
				}
			}
		}
		this.TablesRead = true;
		if (this.InAddr > this.ReadTop) {
			return false;
		}
		this.MakeDecodeTables(array2, 0, 0);
		this.MakeDecodeTables(array2, 299, 1);
		this.MakeDecodeTables(array2, 359, 4);
		this.MakeDecodeTables(array2, 376, 2);
		System.arraycopy(array2, 0, this.UnpOldTable, 0, this.UnpOldTable.length);
		return true;
	}

	void UnpInitData(final boolean b) {
		if (!b) {
			this.TablesRead = false;
			for (int i = 0; i < this.OldDist.length; ++i) {
				this.OldDist[i] = 0;
			}
			this.OldDistPtr = 0;
			final boolean b2 = false;
			this.LastLength = (b2 ? 1 : 0);
			this.LastDist = (b2 ? 1 : 0);
			for (int j = 0; j < Rar.MAXWINSIZE; ++j) {
				this.Window[j] = 0;
			}
			for (int k = 0; k < this.UnpOldTable.length; ++k) {
				this.UnpOldTable[k] = 0;
			}
			final boolean b3 = false;
			this.WrPtr = (b3 ? 1 : 0);
			this.UnpPtr = (b3 ? 1 : 0);
			this.PPMEscChar = 2;
		}
		this.InitBitInput();
		this.PPMError = false;
		this.WrittenFileSize = 0;
		this.ReadTop = 0;
		this.ReadBorder = 0;
		this.UnpInitData20(b);
	}

	void MakeDecodeTables(final byte[] array, final int n, final int n2) {
		final int[] array2 = new int[16];
		final int[] array3 = new int[16];
		final int decodeCnt = this.LL[n2].DecodeCnt;
		for (int i = 0; i < 16; ++i) {
			array2[i] = 0;
		}
		for (int j = 0; j < decodeCnt; ++j) {
			this.DecodeN[this.LL[n2].DecodePtr + j] = 0;
		}
		for (int k = 0; k < decodeCnt; ++k) {
			final int[] array4 = array2;
			final int n3 = array[k + n] & 0xF;
			++array4[n3];
		}
		array2[0] = (array3[0] = 0);
		this.LL[n2].DecodePos[0] = (this.LL[n2].DecodeLen[0] = 0);
		long n4 = 0L;
		for (int l = 1; l < 16; ++l) {
			n4 = 2L * (n4 + array2[l]);
			long n5 = n4 << 15 - l;
			if (n5 > 65535L) {
				n5 = 65535L;
			}
			this.LL[n2].DecodeLen[l] = (int) n5;
			array3[l] = (this.LL[n2].DecodePos[l] = this.LL[n2].DecodePos[l - 1] + array2[l - 1]);
		}
		for (int n6 = 0; n6 < decodeCnt; ++n6) {
			if (array[n6 + n] != 0) {
				this.DecodeN[this.LL[n2].DecodePtr + array3[array[n6 + n] & 0xF]++] = n6;
			}
		}
		this.LL[n2].MaxNum = decodeCnt;
	}

	void Unpack15(final boolean b) {
		if (this.Suspended) {
			this.UnpPtr = this.WrPtr;
		} else {
			this.UnpInitData(b);
			this.OldUnpInitData(b);
			this.UnpReadBuf();
			if (!b) {
				this.InitHuff();
				this.UnpPtr = 0;
			} else {
				this.UnpPtr = this.WrPtr;
			}
			--this.DestUnpSize;
		}
		if (this.DestUnpSize >= 0) {
			this.GetFlagsBuf();
			this.FlagsCnt = 8;
		}
		while (this.DestUnpSize >= 0) {
			this.UnpPtr &= Rar.MAXWINMASK;
			if (this.InAddr > this.ReadTop - 30 && !this.UnpReadBuf()) {
				break;
			}
			if ((this.WrPtr - this.UnpPtr & Rar.MAXWINMASK) < 270 && this.WrPtr != this.UnpPtr) {
				this.OldUnpWriteBuf();
				if (this.Suspended) {
					return;
				}
			}
			if (this.StMode != 0) {
				this.HuffDecode();
			} else {
				if (--this.FlagsCnt < 0) {
					this.GetFlagsBuf();
					this.FlagsCnt = 7;
				}
				if ((this.FlagBuf & 0x80) != 0x0) {
					this.FlagBuf <<= 1;
					if (this.Nlzb > this.Nhfb) {
						this.LongLZ();
					} else {
						this.HuffDecode();
					}
				} else {
					this.FlagBuf <<= 1;
					if (--this.FlagsCnt < 0) {
						this.GetFlagsBuf();
						this.FlagsCnt = 7;
					}
					if ((this.FlagBuf & 0x80) != 0x0) {
						this.FlagBuf <<= 1;
						if (this.Nlzb > this.Nhfb) {
							this.HuffDecode();
						} else {
							this.LongLZ();
						}
					} else {
						this.FlagBuf <<= 1;
						this.ShortLZ();
					}
				}
			}
		}
		this.OldUnpWriteBuf();
	}

	void OldUnpWriteBuf() {
		if (this.UnpPtr != this.WrPtr) {
			this.UnpSomeRead = true;
		}
		if (this.UnpPtr < this.WrPtr) {
			this.main.UnpWrite(this.WrPtr, -this.WrPtr & Rar.MAXWINMASK);
			this.main.UnpWrite(0, this.UnpPtr);
			this.UnpAllBuf = true;
		} else {
			this.main.UnpWrite(this.WrPtr, this.UnpPtr - this.WrPtr);
		}
		this.WrPtr = this.UnpPtr;
	}

	void ShortLZ() {
		this.NumHuf = 0;
		int getbits = this.getbits();
		if (this.LCount == 2) {
			this.addbits(1);
			if (getbits >= 32768) {
				this.OldCopyString(this.LastDist, this.LastLength);
				return;
			}
			getbits <<= 1;
			this.LCount = 0;
		}
		final int n = getbits >> 8;
		Rar.ShortLen1[1] = (Rar.ShortLen2[3] = this.Buf60 + 3);
		int lastLength;
		if (this.AvrLn1 < 37) {
			for (lastLength = 0; ((n ^ Rar.ShortXor1[lastLength])
					& ~(255 >> Rar.ShortLen1[lastLength])) != 0x0; ++lastLength) {
			}
			this.addbits(Rar.ShortLen1[lastLength]);
		} else {
			for (lastLength = 0; ((n ^ Rar.ShortXor2[lastLength])
					& ~(255 >> Rar.ShortLen2[lastLength])) != 0x0; ++lastLength) {
			}
			this.addbits(Rar.ShortLen2[lastLength]);
		}
		if (lastLength < 9) {
			this.LCount = 0;
			this.AvrLn1 += lastLength;
			this.AvrLn1 -= this.AvrLn1 >> 4;
			int n2 = this.DecodeNum(this.getbits(), 5, Rar.DecHf2, Rar.PosHf2) & 0xFF;
			int lastDist = this.ChSetA[n2];
			if (--n2 != -1) {
				final int[] placeA = this.PlaceA;
				final int n3 = lastDist;
				--placeA[n3];
				final int n4 = this.ChSetA[n2];
				final int[] placeA2 = this.PlaceA;
				final int n5 = n4;
				++placeA2[n5];
				this.ChSetA[n2 + 1] = n4;
				this.ChSetA[n2] = lastDist;
			}
			lastLength += 2;
			this.OldDist[this.OldDistPtr++] = ++lastDist;
			this.OldDistPtr &= 0x3;
			this.LastLength = lastLength;
			this.OldCopyString(this.LastDist = lastDist, lastLength);
			return;
		}
		if (lastLength == 9) {
			++this.LCount;
			this.OldCopyString(this.LastDist, this.LastLength);
			return;
		}
		if (lastLength == 14) {
			this.LCount = 0;
			final int lastLength2 = this.DecodeNum(this.getbits(), 3, Rar.DecL2, Rar.PosL2) + 5;
			final int lastDist2 = this.getbits() >> 1 | 0x8000;
			this.addbits(15);
			this.LastLength = lastLength2;
			this.OldCopyString(this.LastDist = lastDist2, lastLength2);
			return;
		}
		this.LCount = 0;
		final int n6 = lastLength;
		final int lastDist3 = this.OldDist[this.OldDistPtr - (lastLength - 9) & 0x3];
		int lastLength3 = this.DecodeNum(this.getbits(), 2, Rar.DecL1, Rar.PosL1) + 2;
		if (lastLength3 == 257 && n6 == 10) {
			this.Buf60 ^= 0x1;
			return;
		}
		if (lastDist3 > 256) {
			++lastLength3;
		}
		if (lastDist3 >= this.MaxDist3) {
			++lastLength3;
		}
		this.OldDist[this.OldDistPtr++] = lastDist3;
		this.OldDistPtr &= 0x3;
		this.LastLength = lastLength3;
		this.OldCopyString(this.LastDist = lastDist3, lastLength3);
	}

	void LongLZ() {
		this.NumHuf = 0;
		this.Nlzb += 16;
		if (this.Nlzb > 255) {
			this.Nlzb = 144;
			this.Nhfb >>= 1;
		}
		final int avrLn2 = this.AvrLn2;
		final int getbits = this.getbits();
		int lastLength;
		if (this.AvrLn2 >= 122) {
			lastLength = this.DecodeNum(getbits, 3, Rar.DecL2, Rar.PosL2);
		} else if (this.AvrLn2 >= 64) {
			lastLength = this.DecodeNum(getbits, 2, Rar.DecL1, Rar.PosL1);
		} else if (getbits < 256) {
			lastLength = getbits;
			this.addbits(16);
		} else {
			for (lastLength = 0; (getbits << lastLength & 0x8000) == 0x0; ++lastLength) {
			}
			this.addbits(lastLength + 1);
		}
		this.AvrLn2 += lastLength;
		this.AvrLn2 -= this.AvrLn2 >> 5;
		final int getbits2 = this.getbits();
		int n;
		if (this.AvrPlcB > 10495) {
			n = this.DecodeNum(getbits2, 5, Rar.DecHf2, Rar.PosHf2);
		} else if (this.AvrPlcB > 1791) {
			n = this.DecodeNum(getbits2, 5, Rar.DecHf1, Rar.PosHf1);
		} else {
			n = this.DecodeNum(getbits2, 4, Rar.DecHf0, Rar.PosHf0);
		}
		this.AvrPlcB += n;
		this.AvrPlcB -= this.AvrPlcB >> 8;
		int n2;
		int n3;
		while (true) {
			n2 = this.ChSetB[n & 0xFF];
			n3 = this.NToPlB[n2++ & 0xFF]++;
			if ((n2 & 0xFF) != 0x0) {
				break;
			}
			this.CorrHuff(this.ChSetB, this.NToPlB);
		}
		this.ChSetB[n] = this.ChSetB[n3];
		this.ChSetB[n3] = n2;
		final int lastDist = ((n2 & 0xFF00) | this.getbits() >> 8) >> 1;
		this.addbits(7);
		final int avrLn3 = this.AvrLn3;
		if (lastLength != 1 && lastLength != 4) {
			if (lastLength == 0 && lastDist <= this.MaxDist3) {
				++this.AvrLn3;
				this.AvrLn3 -= this.AvrLn3 >> 8;
			} else if (this.AvrLn3 > 0) {
				--this.AvrLn3;
			}
		}
		lastLength += 3;
		if (lastDist >= this.MaxDist3) {
			++lastLength;
		}
		if (lastDist <= 256) {
			lastLength += 8;
		}
		if (avrLn3 > 176 || (this.AvrPlc >= 10752 && avrLn2 < 64)) {
			this.MaxDist3 = 32512;
		} else {
			this.MaxDist3 = 8193;
		}
		this.OldDist[this.OldDistPtr++] = lastDist;
		this.OldDistPtr &= 0x3;
		this.LastLength = lastLength;
		this.OldCopyString(this.LastDist = lastDist, lastLength);
	}

	void HuffDecode() {
		final int getbits = this.getbits();
		int n;
		if (this.AvrPlc > 30207) {
			n = this.DecodeNum(getbits, 8, Rar.DecHf4, Rar.PosHf4);
		} else if (this.AvrPlc > 24063) {
			n = this.DecodeNum(getbits, 6, Rar.DecHf3, Rar.PosHf3);
		} else if (this.AvrPlc > 13823) {
			n = this.DecodeNum(getbits, 5, Rar.DecHf2, Rar.PosHf2);
		} else if (this.AvrPlc > 3583) {
			n = this.DecodeNum(getbits, 5, Rar.DecHf1, Rar.PosHf1);
		} else {
			n = this.DecodeNum(getbits, 4, Rar.DecHf0, Rar.PosHf0);
		}
		int n2 = n & 0xFF;
		if (this.StMode != 0) {
			if (n2 == 0 && getbits > 4095) {
				n2 = 256;
			}
			if (--n2 == -1) {
				final int getbits2 = this.getbits();
				this.addbits(1);
				if ((getbits2 & 0x8000) != 0x0) {
					final boolean b = false;
					this.StMode = (b ? 1 : 0);
					this.NumHuf = (b ? 1 : 0);
					return;
				}
				final int n3 = ((getbits2 & 0x4000) != 0x0) ? 4 : 3;
				this.addbits(1);
				final int n4 = this.DecodeNum(this.getbits(), 5, Rar.DecHf2, Rar.PosHf2) << 5 | this.getbits() >> 11;
				this.addbits(5);
				this.OldCopyString(n4, n3);
				return;
			}
		} else if (this.NumHuf++ >= 16 && this.FlagsCnt == 0) {
			this.StMode = 1;
		}
		this.AvrPlc += n2;
		this.AvrPlc -= this.AvrPlc >> 8;
		this.Nhfb += 16;
		if (this.Nhfb > 255) {
			this.Nhfb = 144;
			this.Nlzb >>= 1;
		}
		this.Window[this.UnpPtr++] = (byte) (this.ChSet[n2] >> 8);
		--this.DestUnpSize;
		int n5;
		int n6;
		while (true) {
			n5 = this.ChSet[n2];
			n6 = this.NToPl[n5++ & 0xFF]++;
			if ((n5 & 0xFF) <= 161) {
				break;
			}
			this.CorrHuff(this.ChSet, this.NToPl);
		}
		this.ChSet[n2] = this.ChSet[n6];
		this.ChSet[n6] = n5;
	}

	void GetFlagsBuf() {
		final int decodeNum = this.DecodeNum(this.getbits(), 5, Rar.DecHf2, Rar.PosHf2);
		int n;
		int n2;
		while (true) {
			n = this.ChSetC[decodeNum];
			this.FlagBuf = n >> 8;
			n2 = this.NToPlC[n++ & 0xFF]++;
			if ((n & 0xFF) != 0x0) {
				break;
			}
			this.CorrHuff(this.ChSetC, this.NToPlC);
		}
		this.ChSetC[decodeNum] = this.ChSetC[n2];
		this.ChSetC[n2] = n;
	}

	void OldUnpInitData(final boolean b) {
		if (!b) {
			final boolean b2 = false;
			this.Buf60 = (b2 ? 1 : 0);
			this.NumHuf = (b2 ? 1 : 0);
			this.AvrLn3 = (b2 ? 1 : 0);
			this.AvrLn2 = (b2 ? 1 : 0);
			this.AvrLn1 = (b2 ? 1 : 0);
			this.AvrPlcB = (b2 ? 1 : 0);
			this.AvrPlc = 13568;
			this.MaxDist3 = 8193;
			final int n = 128;
			this.Nlzb = n;
			this.Nhfb = n;
		}
		this.FlagsCnt = 0;
		this.FlagBuf = 0;
		this.StMode = 0;
		this.LCount = 0;
		this.ReadTop = 0;
	}

	void memset(final byte[] array) {
		for (int i = 0; i < array.length; ++i) {
			array[i] = 0;
		}
	}

	void memset(final int[] array) {
		for (int i = 0; i < array.length; ++i) {
			array[i] = 0;
		}
	}

	void InitHuff() {
		for (int i = 0; i < 256; ++i) {
			final int[] place = this.Place;
			final int n = i;
			final int[] placeA = this.PlaceA;
			final int n2 = i;
			final int[] placeB = this.PlaceB;
			final int n3 = i;
			final int n4 = i;
			placeB[n3] = n4;
			place[n] = (placeA[n2] = n4);
			this.PlaceC[i] = (~i + 1 & 0xFF);
			this.ChSet[i] = (this.ChSetB[i] = i << 8);
			this.ChSetA[i] = i;
			this.ChSetC[i] = (~i + 1 & 0xFF) << 8;
		}
		this.memset(this.NToPl);
		this.memset(this.NToPlB);
		this.memset(this.NToPlC);
		this.CorrHuff(this.ChSetB, this.NToPlB);
	}

	void CorrHuff(final int[] array, final int[] array2) {
		int n = 0;
		for (int i = 7; i >= 0; --i) {
			for (int j = 0; j < 32; ++j, ++n) {
				array[n] = ((array[n] & 0xFFFFFF00) | i);
			}
		}
		for (int k = 0; k < array2.length; ++k) {
			array2[k] = 0;
		}
		for (int l = 6; l >= 0; --l) {
			array2[l] = (7 - l) * 32;
		}
	}

	void OldCopyString(final int n, int n2) {
		int n3 = this.UnpPtr - n;
		if (n3 < 0) {
			n3 += Rar.MAXWINSIZE;
		}
		this.DestUnpSize -= n2;
		while (n2-- > 0) {
			this.Window[this.UnpPtr] = this.Window[n3++ & Rar.MAXWINMASK];
			this.UnpPtr = (this.UnpPtr + 1 & Rar.MAXWINMASK);
		}
	}

	int DecodeNum(int n, int n2, final int[] array, final int[] array2) {
		int n3;
		for (n &= 0xFFF0, n3 = 0; array[n3] <= n; ++n3) {
			++n2;
		}
		this.addbits(n2);
		return (n - ((n3 != 0) ? array[n3 - 1] : 0) >> 16 - n2) + array2[n2];
	}

	void CopyString20(int i, final int lastDist) {
		this.OldDist[this.OldDistPtr++ & 0x3] = lastDist;
		this.LastDist = lastDist;
		this.LastLength = i;
		this.DestUnpSize -= i;
		int n = this.UnpPtr - lastDist;
		if (n < 0) {
			n += Rar.MAXWINSIZE;
		}
		if (n < Rar.MAXWINSIZE - 300 && this.UnpPtr < Rar.MAXWINSIZE - 300) {
			this.Window[this.UnpPtr++] = this.Window[n++];
			this.Window[this.UnpPtr++] = this.Window[n++];
			while (i > 2) {
				--i;
				this.Window[this.UnpPtr++] = this.Window[n++];
			}
		} else {
			while (i-- > 0) {
				this.Window[this.UnpPtr] = this.Window[n++ & Rar.MAXWINMASK];
				this.UnpPtr = (this.UnpPtr + 1 & Rar.MAXWINMASK);
			}
		}
	}

	void Unpack20(final boolean b) {
		if (this.Suspended) {
			this.UnpPtr = this.WrPtr;
		} else {
			this.UnpInitData(b);
			if (!this.UnpReadBuf()) {
				return;
			}
			if (!b && !this.ReadTables20()) {
				return;
			}
			--this.DestUnpSize;
		}
		while (this.DestUnpSize >= 0) {
			this.UnpPtr &= Rar.MAXWINMASK;
			if (this.InAddr > this.ReadTop - 30 && !this.UnpReadBuf()) {
				break;
			}
			if ((this.WrPtr - this.UnpPtr & Rar.MAXWINMASK) < 270 && this.WrPtr != this.UnpPtr) {
				this.OldUnpWriteBuf();
				if (this.Suspended) {
					return;
				}
			}
			if (this.UnpAudioBlock != 0) {
				final int decodeNumber = this.DecodeNumber(9 + this.UnpCurChannel);
				if (decodeNumber == 256) {
					if (!this.ReadTables20()) {
						break;
					}
					continue;
				} else {
					this.Window[this.UnpPtr++] = this.DecodeAudio(decodeNumber);
					if (++this.UnpCurChannel == this.UnpChannels) {
						this.UnpCurChannel = 0;
					}
					--this.DestUnpSize;
				}
			} else {
				int decodeNumber2 = this.DecodeNumber(5);
				if (decodeNumber2 < 256) {
					this.Window[this.UnpPtr++] = (byte) decodeNumber2;
					--this.DestUnpSize;
				} else if (decodeNumber2 > 269) {
					final byte[] lDecode = Rar.LDecode;
					decodeNumber2 -= 270;
					int n = (lDecode[decodeNumber2] & 0xFF) + 3;
					final int n2;
					if ((n2 = (Rar.LBits[decodeNumber2] & 0xFF)) > 0) {
						n += this.getbits() >> 16 - n2;
						this.addbits(n2);
					}
					final int decodeNumber3 = this.DecodeNumber(6);
					int n3 = Rar.DDecode[decodeNumber3] + 1;
					final int n4;
					if ((n4 = (Rar.DBits[decodeNumber3] & 0xFF)) > 0) {
						n3 += this.getbits() >> 16 - n4;
						this.addbits(n4);
					}
					if (n3 >= 8192) {
						++n;
						if (n3 >= 262144L) {
							++n;
						}
					}
					this.CopyString20(n, n3);
				} else if (decodeNumber2 == 269) {
					if (!this.ReadTables20()) {
						break;
					}
					continue;
				} else if (decodeNumber2 == 256) {
					this.CopyString20(this.LastLength, this.LastDist);
				} else if (decodeNumber2 < 261) {
					final int n5 = this.OldDist[this.OldDistPtr - (decodeNumber2 - 256) & 0x3];
					final int decodeNumber4 = this.DecodeNumber(7);
					int n6 = (Rar.LDecode[decodeNumber4] & 0xFF) + 2;
					final int n7;
					if ((n7 = (Rar.LBits[decodeNumber4] & 0xFF)) > 0) {
						n6 += this.getbits() >> 16 - n7;
						this.addbits(n7);
					}
					if (n5 >= 257) {
						++n6;
						if (n5 >= 8192) {
							++n6;
							if (n5 >= 262144) {
								++n6;
							}
						}
					}
					this.CopyString20(n6, n5);
				} else {
					if (decodeNumber2 >= 270) {
						continue;
					}
					final byte[] sdDecode = Rar.SDDecode;
					decodeNumber2 -= 261;
					int n8 = (sdDecode[decodeNumber2] & 0xFF) + 1;
					final int n9;
					if ((n9 = (Rar.SDBits[decodeNumber2] & 0xFF)) > 0) {
						n8 += this.getbits() >> 16 - n9;
						this.addbits(n9);
					}
					this.CopyString20(2, n8);
				}
			}
		}
		this.ReadLastTables();
		this.OldUnpWriteBuf();
	}

	boolean ReadTables20() {
		final byte[] array = new byte[19];
		final byte[] array2 = new byte[1028];
		if (this.InAddr > this.ReadTop - 25 && !this.UnpReadBuf()) {
			return false;
		}
		final int getbits = this.getbits();
		this.UnpAudioBlock = (getbits & 0x8000);
		if ((getbits & 0x4000) == 0x0) {
			this.memset(this.UnpOldTable20);
		}
		this.addbits(2);
		int n;
		if (this.UnpAudioBlock != 0) {
			this.UnpChannels = (getbits >> 12 & 0x3) + 1;
			if (this.UnpCurChannel >= this.UnpChannels) {
				this.UnpCurChannel = 0;
			}
			this.addbits(2);
			n = 257 * this.UnpChannels;
		} else {
			n = 374;
		}
		for (int i = 0; i < 19; ++i) {
			array[i] = (byte) (this.getbits() >> 12);
			this.addbits(4);
		}
		this.MakeDecodeTables(array, 0, 8);
		for (int j = 0; j < n; ++j) {
			if (this.InAddr > this.ReadTop - 5 && !this.UnpReadBuf()) {
				return false;
			}
			final int decodeNumber = this.DecodeNumber(8);
			if (decodeNumber < 16) {
				array2[j] = (byte) (decodeNumber + this.UnpOldTable20[j] & 0xF);
			} else if (decodeNumber == 16) {
				int n2 = (this.getbits() >> 14) + 3;
				this.addbits(2);
				while (n2-- > 0 && j < n) {
					array2[j] = array2[j - 1];
					++j;
				}
			} else {
				int n3;
				if (decodeNumber == 17) {
					n3 = (this.getbits() >> 13) + 3;
					this.addbits(3);
				} else {
					n3 = (this.getbits() >> 9) + 11;
					this.addbits(7);
				}
				while (n3-- > 0 && j < n) {
					array2[j++] = 0;
				}
			}
		}
		if (this.InAddr > this.ReadTop) {
			return true;
		}
		if (this.UnpAudioBlock != 0) {
			for (int k = 0; k < this.UnpChannels; ++k) {
				this.MakeDecodeTables(array2, k * 257, 9 + k);
			}
		} else {
			this.MakeDecodeTables(array2, 0, 5);
			this.MakeDecodeTables(array2, 298, 6);
			this.MakeDecodeTables(array2, 346, 7);
		}
		System.arraycopy(array2, 0, this.UnpOldTable20, 0, this.UnpOldTable20.length);
		return true;
	}

	void ReadLastTables() {
		if (this.ReadTop >= this.InAddr + 5) {
			if (this.UnpAudioBlock != 0) {
				if (this.DecodeNumber(9 + this.UnpCurChannel) == 256) {
					this.ReadTables20();
				}
			} else if (this.DecodeNumber(5) == 269) {
				this.ReadTables20();
			}
		}
	}

	void UnpInitData20(final boolean b) {
		if (!b) {
			final boolean b2 = false;
			this.UnpCurChannel = (b2 ? 1 : 0);
			this.UnpChannelDelta = (b2 ? 1 : 0);
			this.UnpChannels = 1;
			this.clrAudV();
			this.memset(this.UnpOldTable20);
		}
	}

	byte DecodeAudio(final int n) {
		final Rar.AudioVariables audioVariables = this.AudV[this.UnpCurChannel];
		++audioVariables.ByteCount;
		this.AudV[this.UnpCurChannel].D4 = this.AudV[this.UnpCurChannel].D3;
		this.AudV[this.UnpCurChannel].D3 = this.AudV[this.UnpCurChannel].D2;
		this.AudV[this.UnpCurChannel].D2 = this.AudV[this.UnpCurChannel].LastDelta - this.AudV[this.UnpCurChannel].D1;
		this.AudV[this.UnpCurChannel].D1 = this.AudV[this.UnpCurChannel].LastDelta;
		final int lastChar = (8 * this.AudV[this.UnpCurChannel].LastChar
				+ this.AudV[this.UnpCurChannel].K1 * this.AudV[this.UnpCurChannel].D1
				+ this.AudV[this.UnpCurChannel].K2 * this.AudV[this.UnpCurChannel].D2
				+ this.AudV[this.UnpCurChannel].K3 * this.AudV[this.UnpCurChannel].D3
				+ this.AudV[this.UnpCurChannel].K4 * this.AudV[this.UnpCurChannel].D4
				+ this.AudV[this.UnpCurChannel].K5 * this.UnpChannelDelta >> 3 & 0xFF) - n;
		final int n2 = (byte) n << 3;
		final int[] dif = this.AudV[this.UnpCurChannel].Dif;
		final int n3 = 0;
		dif[n3] += this.abs(n2);
		final int[] dif2 = this.AudV[this.UnpCurChannel].Dif;
		final int n4 = 1;
		dif2[n4] += this.abs(n2 - this.AudV[this.UnpCurChannel].D1);
		final int[] dif3 = this.AudV[this.UnpCurChannel].Dif;
		final int n5 = 2;
		dif3[n5] += this.abs(n2 + this.AudV[this.UnpCurChannel].D1);
		final int[] dif4 = this.AudV[this.UnpCurChannel].Dif;
		final int n6 = 3;
		dif4[n6] += this.abs(n2 - this.AudV[this.UnpCurChannel].D2);
		final int[] dif5 = this.AudV[this.UnpCurChannel].Dif;
		final int n7 = 4;
		dif5[n7] += this.abs(n2 + this.AudV[this.UnpCurChannel].D2);
		final int[] dif6 = this.AudV[this.UnpCurChannel].Dif;
		final int n8 = 5;
		dif6[n8] += this.abs(n2 - this.AudV[this.UnpCurChannel].D3);
		final int[] dif7 = this.AudV[this.UnpCurChannel].Dif;
		final int n9 = 6;
		dif7[n9] += this.abs(n2 + this.AudV[this.UnpCurChannel].D3);
		final int[] dif8 = this.AudV[this.UnpCurChannel].Dif;
		final int n10 = 7;
		dif8[n10] += this.abs(n2 - this.AudV[this.UnpCurChannel].D4);
		final int[] dif9 = this.AudV[this.UnpCurChannel].Dif;
		final int n11 = 8;
		dif9[n11] += this.abs(n2 + this.AudV[this.UnpCurChannel].D4);
		final int[] dif10 = this.AudV[this.UnpCurChannel].Dif;
		final int n12 = 9;
		dif10[n12] += this.abs(n2 - this.UnpChannelDelta);
		final int[] dif11 = this.AudV[this.UnpCurChannel].Dif;
		final int n13 = 10;
		dif11[n13] += this.abs(n2 + this.UnpChannelDelta);
		final Rar.AudioVariables audioVariables2 = this.AudV[this.UnpCurChannel];
		final byte b = (byte) (lastChar - this.AudV[this.UnpCurChannel].LastChar);
		audioVariables2.LastDelta = b;
		this.UnpChannelDelta = b;
		this.AudV[this.UnpCurChannel].LastChar = lastChar;
		if ((this.AudV[this.UnpCurChannel].ByteCount & 0x1F) == 0x0) {
			int n14 = this.AudV[this.UnpCurChannel].Dif[0];
			int n15 = 0;
			this.AudV[this.UnpCurChannel].Dif[0] = 0;
			for (int i = 1; i < this.AudV.length; ++i) {
				if (this.AudV[this.UnpCurChannel].Dif[i] < n14) {
					n14 = this.AudV[this.UnpCurChannel].Dif[i];
					n15 = i;
				}
				this.AudV[this.UnpCurChannel].Dif[i] = 0;
			}
			switch (n15) {
			case 1: {
				if (this.AudV[this.UnpCurChannel].K1 >= -16) {
					final Rar.AudioVariables audioVariables3 = this.AudV[this.UnpCurChannel];
					--audioVariables3.K1;
					break;
				}
				break;
			}
			case 2: {
				if (this.AudV[this.UnpCurChannel].K1 < 16) {
					final Rar.AudioVariables audioVariables4 = this.AudV[this.UnpCurChannel];
					++audioVariables4.K1;
					break;
				}
				break;
			}
			case 3: {
				if (this.AudV[this.UnpCurChannel].K2 >= -16) {
					final Rar.AudioVariables audioVariables5 = this.AudV[this.UnpCurChannel];
					--audioVariables5.K2;
					break;
				}
				break;
			}
			case 4: {
				if (this.AudV[this.UnpCurChannel].K2 < 16) {
					final Rar.AudioVariables audioVariables6 = this.AudV[this.UnpCurChannel];
					++audioVariables6.K2;
					break;
				}
				break;
			}
			case 5: {
				if (this.AudV[this.UnpCurChannel].K3 >= -16) {
					final Rar.AudioVariables audioVariables7 = this.AudV[this.UnpCurChannel];
					--audioVariables7.K3;
					break;
				}
				break;
			}
			case 6: {
				if (this.AudV[this.UnpCurChannel].K3 < 16) {
					final Rar.AudioVariables audioVariables8 = this.AudV[this.UnpCurChannel];
					++audioVariables8.K3;
					break;
				}
				break;
			}
			case 7: {
				if (this.AudV[this.UnpCurChannel].K4 >= -16) {
					final Rar.AudioVariables audioVariables9 = this.AudV[this.UnpCurChannel];
					--audioVariables9.K4;
					break;
				}
				break;
			}
			case 8: {
				if (this.AudV[this.UnpCurChannel].K4 < 16) {
					final Rar.AudioVariables audioVariables10 = this.AudV[this.UnpCurChannel];
					++audioVariables10.K4;
					break;
				}
				break;
			}
			case 9: {
				if (this.AudV[this.UnpCurChannel].K5 >= -16) {
					final Rar.AudioVariables audioVariables11 = this.AudV[this.UnpCurChannel];
					--audioVariables11.K5;
					break;
				}
				break;
			}
			case 10: {
				if (this.AudV[this.UnpCurChannel].K5 < 16) {
					final Rar.AudioVariables audioVariables12 = this.AudV[this.UnpCurChannel];
					++audioVariables12.K5;
					break;
				}
				break;
			}
			}
		}
		return (byte) lastChar;
	}

	int abs(final int n) {
		return (n < 0) ? (-n) : n;
	}

	static {
		Rar.MAX_SIZE = 32768;
		Rar.MAXWINSIZE = 524288;
		Rar.MAXWINMASK = Rar.MAXWINSIZE - 1;
		LDecode = new byte[] { 0, 1, 2, 3, 4, 5, 6, 7, 8, 10, 12, 14, 16, 20, 24, 28, 32, 40, 48, 56, 64, 80, 96, 112,
				-128, -96, -64, -32 };
		LBits = new byte[] { 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5 };
		DDecode = new int[] { 0, 1, 2, 3, 4, 6, 8, 12, 16, 24, 32, 48, 64, 96, 128, 192, 256, 384, 512, 768, 1024, 1536,
				2048, 3072, 4096, 6144, 8192, 12288, 16384, 24576, 32768, 49152, 65536, 98304, 131072, 196608, 262144,
				327680, 393216, 458752, 524288, 589824, 655360, 720896, 786432, 851968, 917504, 983040 };
		DBits = new byte[] { 0, 0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9, 10, 10, 11, 11, 12, 12,
				13, 13, 14, 14, 15, 15, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16 };
		DBitLengthCounts = new int[] { 4, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 14, 0, 12 };
		SDDecode = new byte[] { 0, 4, 8, 16, 32, 64, -128, -64 };
		SDBits = new byte[] { 2, 2, 3, 4, 5, 6, 6, 6 };
		DecL1 = new int[] { 32768, 40960, 49152, 53248, 57344, 59904, 60928, 61440, 61952, 61952, 65535 };
		PosL1 = new int[] { 0, 0, 0, 2, 3, 5, 7, 11, 16, 20, 24, 32, 32 };
		DecL2 = new int[] { 40960, 49152, 53248, 57344, 59904, 60928, 61440, 61952, 62016, 65535 };
		PosL2 = new int[] { 0, 0, 0, 0, 5, 7, 9, 13, 18, 22, 26, 34, 36 };
		DecHf0 = new int[] { 32768, 49152, 57344, 61952, 61952, 61952, 61952, 61952, 65535 };
		PosHf0 = new int[] { 0, 0, 0, 0, 0, 8, 16, 24, 33, 33, 33, 33, 33 };
		DecHf1 = new int[] { 8192, 49152, 57344, 61440, 61952, 61952, 63456, 65535 };
		PosHf1 = new int[] { 0, 0, 0, 0, 0, 0, 4, 44, 60, 76, 80, 80, 127 };
		DecHf2 = new int[] { 4096, 9216, 32768, 49152, 64000, 65535, 65535, 65535 };
		PosHf2 = new int[] { 0, 0, 0, 0, 0, 0, 2, 7, 53, 117, 233, 0, 0 };
		DecHf3 = new int[] { 2048, 9216, 60928, 65152, 65535, 65535, 65535 };
		PosHf3 = new int[] { 0, 0, 0, 0, 0, 0, 0, 2, 16, 218, 251, 0, 0 };
		DecHf4 = new int[] { 65280, 65535, 65535, 65535, 65535, 65535 };
		PosHf4 = new int[] { 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 0, 0, 0 };
		Rar.ShortLen1 = new int[] { 1, 3, 4, 4, 5, 6, 7, 8, 8, 4, 4, 5, 6, 6, 4, 0 };
		Rar.ShortXor1 = new int[] { 0, 160, 208, 224, 240, 248, 252, 254, 255, 192, 128, 144, 152, 156, 176 };
		Rar.ShortLen2 = new int[] { 2, 3, 3, 3, 4, 4, 5, 6, 6, 4, 4, 5, 6, 6, 4, 0 };
		Rar.ShortXor2 = new int[] { 0, 64, 96, 160, 208, 224, 240, 248, 252, 192, 128, 144, 152, 156, 176 };
		LLSize = new int[] { 299, 60, 28, 20, 17, 298, 48, 28, 19, 257, 257, 257, 257 };
	}

	class Decode {
		int MaxNum;
		int[] DecodeLen;
		int[] DecodePos;
		int DecodePtr;
		int DecodeCnt;

		Decode(final Rar this$0) {
			this.DecodeLen = new int[16];
			this.DecodePos = new int[16];
		}
	}

	class AudioVariables {
		int K1;
		int K2;
		int K3;
		int K4;
		int K5;
		int D1;
		int D2;
		int D3;
		int D4;
		int LastDelta;
		int[] Dif;
		int ByteCount;
		int LastChar;

		AudioVariables(final Rar this$0) {
			this.Dif = new int[11];
		}
	}

}
