import javax.microedition.io.*;
import java.io.*;

public class SevenZip {
	int getpos;
	Main main;
	Decode decoder;

	SevenZip(final Main main) {
		this.getpos = 0;
		this.decoder = null;
		this.main = main;
	}

	int get8b(final byte[] array) {
		int n;
		byte b;
		for (n = 0, b = array[this.getpos]; b < 0; b <<= 1, ++n) {
		}
		int n2 = b >>> n;
		switch (n) {
		case 1: {
			n2 = (n2 << 8 | (array[++this.getpos] & 0xFF));
			break;
		}
		case 2: {
			n2 = (n2 << 16 | (array[++this.getpos] & 0xFF) | (array[++this.getpos] & 0xFF) << 8);
			break;
		}
		case 3: {
			n2 = (n2 << 24 | (array[++this.getpos] & 0xFF) | (array[++this.getpos] & 0xFF) << 8
					| (array[++this.getpos] & 0xFF) << 16);
			break;
		}
		}
		++this.getpos;
		return n2;
	}

	public int unpack(final StreamConnection streamConnection, final String s) {
		try {
			final InputStream openInputStream = streamConnection.openInputStream();
			this.main.os = null;
			final byte[] array = new byte[32];
			if (openInputStream.read(array, 0, 32) != 32) {
				return 1;
			}
			final int n = (array[12] & 0xFF) | (array[13] & 0xFF) << 8 | (array[14] & 0xFF) << 16
					| (array[15] & 0xFF) << 24;
			final int n2 = (array[20] & 0xFF) | (array[21] & 0xFF) << 8 | (array[22] & 0xFF) << 16
					| (array[23] & 0xFF) << 24;
			openInputStream.close();
			InputStream inputStream = streamConnection.openInputStream();
			inputStream.skip(n + 32);
			if (inputStream.read(array, 0, 32) != 32) {
				return 2;
			}
			this.decoder = new Decode();
			if (!this.decoder.SetDecoderProperties()) {
				return 3;
			}
			int get8b;
			if (array[0] == 1 && array[1] == 4 && array[2] == 6) {
				System.arraycopy(array, 0, this.decoder.m_OutWindow._buffer, 0, 32);
				inputStream.read(this.decoder.m_OutWindow._buffer, 32, n2 - 32);
				get8b = n2;
			} else {
				if (array[0] != 23 || array[1] != 6) {
					return 4;
				}
				this.getpos = 2;
				while (this.getpos < 31 && (array[this.getpos] != 0 || array[this.getpos + 1] != 12)) {
					++this.getpos;
				}
				if (array[++this.getpos] != 12) {
					return 5;
				}
				++this.getpos;
				get8b = this.get8b(array);
				inputStream.close();
				inputStream = streamConnection.openInputStream();
				this.getpos = 2;
				inputStream.skip(32 + this.get8b(array));
				if (!this.decoder.Code(this.main, this.main.zipbuf, inputStream, this.main.os, get8b)) {
					return 6;
				}
			}
			final byte[] buffer = this.decoder.m_OutWindow._buffer;
			if (buffer[0] != 1 || buffer[1] != 4 || buffer[2] != 6 || buffer[3] != 0) {
				return 7;
			}
			this.getpos = 4;
			final int get8b2 = this.get8b(buffer);
			if (buffer[this.getpos++] != 9) {
				return 8;
			}
			final int[] array2 = new int[get8b2];
			for (int i = 0; i < get8b2; ++i) {
				array2[i] = this.get8b(buffer);
			}
			while (this.getpos < get8b - 1 && (buffer[this.getpos] != 0 || buffer[this.getpos + 1] != 12)) {
				++this.getpos;
			}
			if (buffer[++this.getpos] != 12) {
				return 9;
			}
			++this.getpos;
			final int[] array3 = new int[get8b2];
			int j;
			for (j = 0; j < get8b2; ++j) {
				array3[j] = this.get8b(buffer);
			}
			while (this.getpos < get8b - 1 && (buffer[this.getpos] != 0 || buffer[this.getpos + 1] != 5)) {
				++this.getpos;
			}
			if (buffer[++this.getpos] != 5) {
				return 10;
			}
			++this.getpos;
			this.get8b(buffer);
			int getempty = 0;
			if (buffer[this.getpos] == 14) {
				++this.getpos;
				getempty = this.getempty(buffer, ++this.getpos, j >> 3);
				this.getpos += j >> 3;
				while (buffer[++this.getpos] == 0) {
				}
			}
			if (buffer[this.getpos] == 17) {
				++this.getpos;
				this.get8b(buffer);
			}
			--this.getpos;
			while (buffer[++this.getpos] == 0) {
			}
			final char[] array4 = new char[get8b >> 1];
			int n4;
			for (int n3 = n4 = 0; n4 < array4.length && n3 < j; ++n4) {
				array4[n4] = (char) ((buffer[this.getpos++] & 0xFF) + ((buffer[this.getpos++] & 0xFF) << 8));
				if (array4[n4] == '\0') {
					if (getempty > 0) {
						n3 = (n4 = 0);
						--n4;
						--getempty;
					} else {
						++n3;
					}
				}
			}
			int n6;
			int n5 = n6 = 0;
			int n7 = 32;
			for (int n8 = 0; n8 < get8b2 && !this.main.stop; ++n8) {
				while (array4[n5] != '\0') {
					++n5;
				}
				this.main.fc = this.main.createfile(s, new String(array4, n6, n5 - n6));
				this.main.os = this.main.fc.openOutputStream();
				n6 = ++n5;
				inputStream.close();
				inputStream = streamConnection.openInputStream();
				inputStream.skip(n7);
				if (!this.decoder.Code(this.main, this.main.zipbuf, inputStream, this.main.os, array3[n8])) {
					return 11;
				}
				n7 += array2[n8];
				this.main.os.close();
				this.main.fc.close();
			}
			inputStream.close();
		} catch (IOException ex) {
			return 12;
		}
		return 0;
	}

	boolean strcmp(final char[] array, int n, int n2, int n3) {
		while (--n3 >= 0) {
			if (array[n++] != array[n2++]) {
				return false;
			}
		}
		return true;
	}

	int getempty(final byte[] array, int n, final int n2) {
		int n3 = 0;
		Block_2: while (true) {
			int n4 = array[n++] & 0xFF;
			for (int i = 0; i < 8; ++i) {
				if ((n4 & 0x80) == 0x0) {
					break Block_2;
				}
				n4 <<= 1;
				++n3;
			}
		}
		return n3;
	}
}
